#!/usr/bin/env ruby

require 'catalog'
require 'config'
require 'tsslock'
require 'tss'
require 'login'

require 'cgi'

cgi = CGI.new

login = Login.new(cgi)

cmd = cgi['cmd']

def moved_temporary(loc)
  print "Status Code: 302 Moved Temporary\n"
  print "Location: #{loc}\n\n"
end

if (cmd != '')
  if (cmd == 'conf')
    if (File.exists?('db/vil.db') && !login.admin? && ADMIN != '')
      print "Content-Type: text/plain\n\n"
      print "Ԥǥ󤷤Ʋ\n"
      exit(0)
    end

    File.open('config.rb') do |ifile|
      File.open('config.tmp', 'w') do |ofile|
        ifile.each do |line|
          if (line =~ /^([A-Z_]+) = '([^']*)'$/)
            if (cgi[$1] != '')
              ofile.print "#{$1} = '#{cgi[$1]}'\n"
            else
              ofile.print line
            end
          else
            ofile.print line
          end
        end
      end
    end
    File.rename('config.tmp', 'config.rb')

    if (!FileTest.exist?('db/vil.db'))
      moved_temporary('admin.cgi?cmd=init')
    end

    moved_temporary('admin.cgi?cmd=edit')
  elsif (cmd == 'edit')
    lock = TSSLock.new(COUNTRY_NAME)
    raise ErrorMsg.new('ʤ󤫥åǤƤޤ') if (!lock.lock('vil'))

    begin
      srvdb = Store.new('db/srv.db')
      srvdb.transaction do
        if (!srvdb.root?(COUNTRY_NAME))
          raise ErrorMsg.new('̾Ѥʤǲ')
        end

        srvdb[COUNTRY_NAME]['serv'] = MY_SERV
        srvdb[COUNTRY_NAME]['path'] = MY_PATH
        srvdb[COUNTRY_NAME]['sig'] = TK_TOKEN
      end

      http_broadcast('db/srv.db')

      lock.unlock('vil')
    rescue
      lock.unlock('vil')

      print "Content-Type: text/plain; charset=euc-jp\r\n\r\n"
      print "Ȥ˼Ԥޤ\n"
      print "Ƽ¹ԤƤߤƤ\n"
      print "#{$!}\n"
      print $!.backtrace.join("\n") + "\n"
      exit(0)
    end
  elsif (cmd == 'init')
    lock = TSSLock.new(COUNTRY_NAME)
    raise ErrorMsg.new('ʤ󤫥åǤƤޤ') if (!lock.lock('vil'))

    begin
      http_get(INIT_SERV, INIT_PATH, 'db/srv.db', INIT_PASS)

      srvdb = Store.new('db/srv.db')

      srvdb.transaction do
        if (srvdb.root?(COUNTRY_NAME))
          raise ErrorMsg.new('¸ߤƤ̾Ǥ')
        end

        srvdb[COUNTRY_NAME] = Hash.new
        srvdb[COUNTRY_NAME]['serv'] = MY_SERV
        srvdb[COUNTRY_NAME]['path'] = MY_PATH
        srvdb[COUNTRY_NAME]['sig'] = TK_TOKEN
      end

      http_broadcast('db/srv.db')

      http_get(INIT_SERV, INIT_PATH, 'db/vil.db', INIT_PASS)
      http_get(INIT_SERV, INIT_PATH, 'db/user.db', INIT_PASS)

      lock.unlock('vil')
    rescue
      lock.unlock('vil')

      print "Content-Type: text/plain; charset=euc-jp\r\n\r\n"
      print "Ȥ˼Ԥޤ\n"
      print "Ƽ¹ԤƤߤƤ\n"
      print "#{$!}\n"
      print $!.backtrace.join("\n") + "\n"
      exit(0)
    end
  end

  moved_temporary('admin.cgi')
else
  print "Content-Type: text/html\n\n"

  print HEAD

  login.form

  print %Q(<h2></h2>)
  print %Q(<form method="POST"><input type="hidden" name="cmd" value="conf">)
  print %Q(<p>ʲιܤϤꤷƲ</p>)
  print %Q(<table border="1">)
  print %Q(<tr><td>̾ (:she)</td><td><input name="COUNTRY_NAME" value="#{COUNTRY_NAME}"></td></tr>)
  print %Q(<tr><td>TypeKeyȡ (:SVv6mUu3vltZSam2HGXM)</td><td><input name="TK_TOKEN" value="#{TK_TOKEN}"></td></tr>)
  print %Q(<tr><td>Ԥ TypeKey ID (:shikoku)</td><td><input name="ADMIN" value="#{ADMIN}"></td></tr>)
  print %Q(<tr><td>ʬФ˻äΤɬפʥѥ (she˳ǧƲ)</td><td><input name="INIT_PASS" value="#{INIT_PASS}"></td></tr>)
  print %Q(</table>)
  print %Q(<p>ʲιܤϤ餯֤ꤢޤ</p>)
  print %Q(<table border="1">)
  print %Q(<tr><td>̾ (:shinh.skr.jp)</td><td><input name="SET_SERV" value="#{MY_SERV}"></td></tr>)
  print %Q(<tr><td>Хѥ (:/shikoku/)</td><td><input name="SET_PATH" value="#{MY_PATH}"></td></tr>)
  print %Q(<tr><td>ޥ TypeKey ID (ֿ侩Ǥץ쥤˻Ѥ ID Ȥ ID Ǥɬפޤ)</td><td><input name="MASTER" value="#{MASTER}"></td></tr>)
  print %Q(<tr><td>ޥ TypeKey nick</td><td><input name="MASTER_NICK" value="#{MASTER_NICK}"></td></tr>)
  print %Q(</table>)
  print %Q(<input type="submit" value=""></form>)

  print "<br>"

  print FOOT
end

