require 'config'

require 'net/http'

class TSSLock
  attr_reader :locked

  def initialize(owner)
    @owner = owner
    @locked = false
  end

  def lock(func)
    res = Net::HTTP.get(LOCKSRV,
                        "#{LOCKPATH}?cmd=lock&func=#{func}&owner=#{@owner}")
    if (res == 'ok')
      @locked = true
    end
    return @locked
  end

  def unlock(func)
    res = Net::HTTP.get(LOCKSRV,
                        "#{LOCKPATH}?cmd=unlock&func=#{func}&owner=#{@owner}")
    if (res == 'ok')
      @locked = false
    end
    return !@locked
  end
end
