#!/usr/bin/env ruby

require 'cgi'
require 'pstore'

require 'tsslog'

cgi = CGI.new

cmd = cgi['cmd'].to_s
func = cgi['func'].to_s
owner = cgi['owner'].to_s

print "Content-Type: text/plain\r\n\r\n"

lockdb = PStore.new('lock.db')
lockdb.transaction do
  if (cmd == 'lock')
    if (lockdb.root?(func))
      tsslog('LOCKSRV',
             "err: func=#{func} owner=#{owner} locked=#{lockdb[func]}")
      print "locked by #{lockdb[func]}"
    elsif (lockdb['_freeze'].include?(owner))
      tsslog('LOCKSRV',
             "freezed: func=#{func} owner=#{owner} locked=#{lockdb[func]}")
      print "freezed"
    else
      tsslog('LOCKSRV',
             "ok: func=#{func} owner=#{owner}")
      lockdb[func] = owner
      print 'ok'
    end
  elsif (cmd == 'unlock')
    if (lockdb[func] == owner)
      lockdb.delete(func)
      tsslog('UNLOCKSRV',
             "ok: func=#{func} owner=#{owner}")
      print 'ok'
    else
      if (lockdb.root?(func))
        tsslog('UNLOCKSRV',
               "err: func=#{func} owner=#{owner} locked=#{lockdb[func]}")
        print "locked by #{lockdb[func]}"
      else
        tsslog('UNLOCKSRV',
               "err: func=#{func} owner=#{owner}")
        print 'not locked'
      end
    end
  elsif (cmd == 'freeze')
    if (!lockdb.root?('_freeze'))
      lockdb['_freeze'] = Array.new
    end
    freeze = cgi['freeze'].to_s
    lockdb['_freeze'].push(freeze) if !lockdb['_freeze'].include?(freeze)
    tsslog('FREEZESRV',
           "ok: func=#{func} owner=#{owner} freeze=#{freeze}")
    print "ok"
  else
    print 'err'
  end
end
