require 'TypeKey'

require 'config'
require 'errormsg'

require 'rbuconv/uconv'

class Login
  attr_reader :userid, :nick, :passwd, :cookie, :login
  attr_accessor :display
  attr_reader :filter, :preview

  def set_cookie(cgi)
    if (!@userid)
      return
    end
    @cookie = CGI::Cookie.new({"name" => 'login', "value" => "#{@sig},#{@userid},#{@display}"})
    @cookie.expires = Time.now + 60*60*24*30
    @cookie.path = MY_PATH
#    @cookie.domain = "shinh.skr.jp"
  end

  def master?
    login && userid == MASTER
  end

  def admin?
    login && userid == ADMIN
  end

  def initialize(cgi)
    userdb = Store.new('db/user.db')

    cookie = cgi.cookies['login']
    cook_disp = nil
    if (cookie.size == 1)
      vals = cookie[0].split(/,/)
      @sig = vals[0]
      @userid = vals[1]
      cook_disp = vals[2]
      @login = userdb.transaction(true) do
        if (userdb.root?(@userid))
          userdb[@userid]['sig'] == @sig
        end
      end
    end

    cmd = cgi['cmd']
    if (cmd == 'logout')
      @login = false
      userdb.transaction do
        if (userdb.root?(@userid))
          userdb[@userid]['sig'] = ''
        end
      end
#      http_broadcast('db/user.db')
#      set_cookie(cgi)
    elsif (cmd == 'login')
      ts = cgi['ts']
      email = cgi['email']
      @userid = cgi['name']
      @nick = cgi['nick']
      @sig = cgi['sig']
      tk = TypeKey.new(TK_TOKEN)
      if (tk.verify(email, @userid, @nick, ts, @sig))
        userdb.transaction do
          if (!userdb.root?(@userid))
            userdb[@userid] = Hash.new
          end
          @nick = Uconv.u8toeuc(@nick)
          userdb[@userid]['sig'] = @sig
          userdb[@userid]['nick'] = @nick
          @login = true
          @display = userdb[@userid]['display'].to_i
          set_cookie(cgi)
        end
#        http_broadcast('db/user.db')
      else
        raise ErrorMsg.new("ǧڤǤƤޤ")
      end
    end

    if (login)
      userdb = Store.new('db/user.db')
      userdb.transaction(true) do
        u = userdb[@userid]
        @display = (u) ? u['display'].to_i : 0
        @nick = u['nick']
        if (@display != cook_disp.to_i)
          set_cookie(cgi)
        end
      end

      urdb = Store.new("db/ur/#{@userid}.db")
      urdb.transaction(true) do
        (@filter, @preview) =
          if (urdb['root'].respond_to?(:filter))
            [urdb['root'].filter, urdb['root'].preview]
          end
      end
    end

    if (cmd == 'login' || cmd == 'logout')
      print "Status Code: 302 Moved Temporary\n"
      print "Set-Cookie: #{@cookie}\n"
      if cgi['vid'].to_i == 0
        print "Location: .\n\n"
      else
        print "Location: ?vid=#{cgi['vid']}\n\n"
      end
      exit(0)
    end
  end

  def form(vid = 0)
    tk = TypeKey.new(TK_TOKEN)
    if (login)
#<form action="#{tk.getLogoutUrl(MY_URL+'?cmd=logout')}" method="GET" class="login_form">
      print <<END
<form action="#{tk.base_url}logout" method="GET" class="login_form">
User ID : #{@nick}
<input type="hidden" name="_return" value="#{URI.escape(MY_URL+"?cmd=logout&vid=#{vid}")}">
<input type="submit" value="logout">
END
    else
      print <<END
<form action="#{tk.base_url}login" method="GET" class="login_form">
<input type="hidden" name="t" value="#{TK_TOKEN}">
<input type="hidden" name="_return" value="#{URI.escape(MY_URL+"?cmd=login&vid=#{vid}")}">
<input type="hidden" name="v" value="1.1">
<input type="submit" value="login">
END
    end
    print <<END
(<a href="http://www.sixapart.jp/typekey/">TypeKey</a>)
</form><br>
END
  end
end
