#!/usr/bin/env ruby

$KCODE = "EUC"

require 'config'
require 'user_record'
require 'catalog'
require 'login'
require 'tss'
require 'tsslock'

require 'cgi'

cgi = CGI.new()

@login = Login.new(cgi)

def cgi_select(name, values, labels, selected)
  r = %Q(<select name="#{name}">)
  values.each_index do |i|
    v = values[i]
    l = labels[i]
    selected_str = (v == selected) ? ' selected' : ''
    r += %Q(<option value="#{v}"#{selected_str}>#{l})
  end
  r + %Q(</select>\n)
end

def update_all
  urdb = Store.new('db/ur.db')
  urdb.transaction() do
    urdb.roots.each do |i|
      u = urdb[i]
      u.update
      urdb[i] = u
    end
  end
end

def rank_table(ta, r)
  print "<table class=\"list\"><tr>"
  print "<th></th>"
  print "<th>ID</th>"
  ta.each do |t|
    print "<th>#{t}</th>"
  end
  print "</tr>"

  r.each_index do |i|
    print "<tr>"
    print "<td>#{i+1}</td>"
    r[i].each do |d|
      print "<td>#{d}</td>"
    end
    print "</tr>"
  end

  print "</table>"
end

def rank_tables(us, prefix = '')
  print "<h2>#{prefix}Ψ󥭥</h2>\n"
  rank_table(['Ψ', ''],
             us.sort do |a, b|
               [b[1].win_rate, b[1].wins] <=>
               [a[1].win_rate, a[1].wins]
             end.collect do |u|
               s = u[1]
               [u[0], "#{s.win_rate}%", "#{s.wins} #{s.loses}"]
             end)

  print "<h2>#{prefix}¸Ψ󥭥</h2>\n"
  rank_table(['¸Ψ', 'ʿѼ̿', 'ÿ'],
             us.sort do |a, b|
               [b[1].live_rate, b[1].avg_dates, b[1].num ] <=>
               [a[1].live_rate, a[1].avg_dates, a[1].num ]
             end.collect do |u|
               s = u[1]
               [u[0], "#{s.live_rate}%", "#{s.avg_dates}", "#{s.num}"]
             end)

  print "<h2>#{prefix}MVPɼ󥭥</h2>\n"
  rank_table(['MVPɼ', 'MVP', 'ÿ'],
             us.sort do |a, b|
               [b[1].mvpcs, b[1].mvps, a[1].num] <=>
               [a[1].mvpcs, a[1].mvps, b[1].num]
             end.collect do |u|
               s = u[1]
               [u[0], "#{s.mvpcs}ɼ", "#{s.mvps}", "#{s.num}"]
             end)
end

def idl(id, nick)
  "<a href=\"matome.cgi?#{CGI.escape(id)}\">#{nick}</a>"
end

def idl_db(userdb, id)
  if (userdb[id])
    idl(id, userdb[id]['nick'])
  else
    udb = Store.new("db/ur/#{CGI.escape(id)}.db")
    udb.transaction(true) do
      if (udb['root'])
        idl(id, udb['root'].nick)
      else
        idl(id, '???')
      end
    end
  end
end

def senseki_table(cls_th, a, cls_proc)
  print "<table class=\"list\"><tr>"
  print "<th>#{cls_th}</th>"
  print "<th></th><th>Ψ</th>"
  print "<th>¸Ψ</th><th>̿</th>"
  print "<th>MVPɼ</th><th>MVP</th>"
  print "</tr>"
  a.each do |s|
    next if (s.num == 0)
    print "<tr>"
    print "<td>#{cls_proc.call(s.cls)}</td>"
    print "<td>#{s.wins}#{s.loses}</td><td>#{s.win_rate}%</td>"
    print "<td>#{s.live_rate}%</td><td>#{s.avg_dates}</td>"
    print "<td>#{s.mvpcs}ɼ</td><td>#{s.mvps}</td>"
    print "</tr>"
  end
  print "</table>"
end

def matome(id)
  if (id != '')
    userdb = Store.new('db/user.db')
    userdb.transaction(true) do
      urdb_file = "db/ur/#{CGI.escape(id)}.db"
      if (!FileTest.exist?(urdb_file))
        print "<p>ޤӤޤ</p>"
      else
        urdb = Store.new(urdb_file)
        u = urdb.transaction(true) do
          urdb['root']
        end

        print "<h1>#{u.nick}</h1>"
        s = u.senseki
        if (s)
          print "#{s.wins} #{s.loses} (Ψ #{s.win_rate}%)<br>"
          print "¸Ψ #{s.live_rate}%, ʿѼ̿ #{s.avg_dates}<br>"
          print "MVP#{s.mvps}, MVPɼ#{s.mvpcs}ɼ<br>"
          print "<br>"
        else
          print "ޤӤޤ"
        end

        print "<h2>ʾҲ</h2>"
        print "<br>"
        if (u.intro)
          print u.intro.gsub(/\n/, '<br>')
        else
          print '<strong>ʾҲ𤬤ޤ˲μʾҲԽǼʾҲäƲ褯狼IDϺǽޤ</strong>'
        end
        print "<br>"
        print "<br>"

        if (s)
          print "<h2>¼εϿ</h2><br><ul>"
          vldb = Store.new('db/vil.db')
          srvdb = Store.new('db/srv.db')
          vldb.transaction(true) do
            srvdb.transaction(true) do
              u.sorted_vils.each do |v|
                vi = vldb['root'].find() do |vi|
                  vi['vid'] == v.vid
                end
                s = srvdb[vi['country']]
                print "<li><strong>#{v.vname}</strong> (<a href=\"http://#{s['serv']}#{s['path']}log_#{v.vid}_info.html\">#{v.vid}¼</a>) #{if (v.mvp) then '' end}<br> #{v.win ? '' : ''} #{v.name} (#{v.skill}) #{v.survive} #{v.death}<br> (#{v.hist})"
              end
            end
          end

          print "</ul><br>\n"

          print "<h2>Ω</h2>"
          senseki_table('Ω', u.senseki_ps, Proc.new {|c| "#{c}¦"})

          print "<h2></h2>"
          senseki_table('', u.senseki_sk, Proc.new {|c| c})

          #          print "<h2></h2>"
          #          senseki_table('', u.senseki_pl, Proc.new {|c| c.sub(/^[^\s]+\s+/, '')})

          winstr = [ '', '', '' ]
          print "<h2></h2>"
          print "<br><ul>"

          vss = Hash.new

          u.vils.each do |v|
            next if (!v.vs)
            print "<li>#{v.vid}: "
            str = v.vs.collect do |kv|
              i = kv[0]
              w = kv[1]+1

              if (!vss.key?(i))
                vss[i] = [0, 0, 0, 0]
              end
              vss[i][0] += 1
              vss[i][w+1] += 1

              "#{winstr[w]}#{idl_db(userdb, i)}"
            end.join(', ')
            print str
          end
          print "</ul><br>\n"

          print "<ul>"
          vss.select do |kv|
            kv[1][0] >= 3
          end.sort do |kv1, kv2|
            v1 = kv1[1]
            v2 = kv2[1]
            [v2[0], v2[3], v2[2], v2[1]] <=> [v1[0], v1[3], v1[2], v1[1]]
          end.each do |kv|
            print "<li>vs. #{idl_db(userdb, kv[0])} #{kv[1][3]} #{kv[1][1]} #{kv[1][2]}ʬ"
          end
          print "</ul><br>\n"
        end

        if (@login.login && @login.userid == id)
          print "<h2>ʾҲԽ</h2>"
          print "<br>"
          print "<form action=\"matome.cgi\" method=\"POST\">"
          print "<textarea name=\"intro\" rows=\"3\" class=\"action_textarea\">#{u.intro}</textarea><br>"
          print "<input type=\"hidden\" name=\"cmd\" value=\"intro\">"
          print "<input type=\"submit\" value=\"Խ\">"
          print "</form>"
          print "<br>"

          print %Q(<h2></h2>
<form action="matome.cgi" method="POST">
<table>
<tr><td>ȯե륿: </td>
<td>
#{cgi_select('filter', ['1','0'], ['ɽ', 'ɽ'], u.filter)}
</td>
</tr>
<tr><td>ץӥ塼: </td>
<td>
#{cgi_select('preview', ['2','1','0'], ['¼ˤ碌','˥','˥'], u.preview)}
</td>
</tr>
</table>
<input type="hidden" name="cmd" value="config">
<input type="submit" value="">
</form>
)
        end
      end
    end
  else
    raise ErrorMsg.new('̤ʤΤ衢뤫狼')
  end
end

print "Content-Type: text/html; charset=EUC-JP\n\n"

begin
  print(HEAD1)
  print "<title>͹</title>"
  print(HEAD2)

  @login.form

  cmd = cgi['cmd']

  u = (cmd == nil) ? '' : CGI::unescape(ENV['QUERY_STRING'])

  if (cmd == 'update')
    update_all
    print "OK"
    exit(0)
  elsif (cmd == 'intro' && @login.login)
    u = CGI.escape(@login.userid)
    urdb = Store.new("db/ur/#{u}.db")
    urdb.transaction() do
      urdb['root'].intro = cgi['intro']
    end
    lock = TSSLock.new(COUNTRY_NAME)
    raise ErrorMsg.new('ʤ󤫥åǤƤޤ') if (!lock.lock('vil'))
    begin
      http_broadcast("db/ur/#{u}.db")
      lock.unlock('vil')
    ensure
      lock.unlock('vil')
    end
  elsif (cmd == 'config' && @login.login)
    u = CGI.escape(@login.userid)
    urdb = Store.new("db/ur/#{u}.db")
    urdb.transaction() do
      urdb['root'].filter = cgi['filter']
      urdb['root'].preview = cgi['preview']
    end
    http_broadcast('db/user.db')
    lock = TSSLock.new(COUNTRY_NAME)
    raise ErrorMsg.new('ʤ󤫥åǤƤޤ') if (!lock.lock('vil'))
    begin
      http_broadcast("db/ur/#{u}.db")
      lock.unlock('vil')
    ensure
      lock.unlock('vil')
    end
  end

  matome(u)

  print(FOOT)
rescue
  print "<pre>\n"
  print CGI.escapeHTML("#{$!.to_s}\n")
  print CGI.escapeHTML("#{$!.backtrace.join("\n")}\n")
  print "</pre>\n"
end

