#!/usr/bin/env ruby

$KCODE = "EUC"

COUNTRY_NAME='mshe'
require 'user_record'
require 'catalog'

require 'cgi'
require 'pstore'

NUM1 = ARGV[0].to_i
NUM2 = ARGV[1].to_i

def rank_table(ta, r)
  print "<table class=\"list\"><tr>"
  print "<th></th>"
  print "<th>ID</th>"
  ta.each do |t|
    print "<th>#{t}</th>"
  end
  print "</tr>"

  r.each_index do |i|
    print "<tr>"
    print "<td>#{i+1}</td>"
    r[i].each do |d|
      print "<td>#{d}</td>"
    end
    print "</tr>"
  end

  print "</table>"
end

def rank_tables(us, prefix = '')
  print "<h2>#{prefix}Ψ󥭥</h2>\n"
  rank_table(['Ψ', ''],
             us.sort do |a, b|
               [b[1].win_rate, b[1].wins] <=>
               [a[1].win_rate, a[1].wins]
             end.collect do |u|
               s = u[1]
               [u[0], "#{s.win_rate}%", "#{s.wins} #{s.loses}"]
             end)

  print "<h2>#{prefix}¸Ψ󥭥</h2>\n"
  rank_table(['¸Ψ', 'ʿѼ̿', 'ÿ'],
             us.sort do |a, b|
               [b[1].live_rate, b[1].avg_dates, b[1].num ] <=>
               [a[1].live_rate, a[1].avg_dates, a[1].num ]
             end.collect do |u|
               s = u[1]
               [u[0], "#{s.live_rate}%", "#{s.avg_dates}", "#{s.num}"]
             end)

  print "<h2>#{prefix}MVPɼ󥭥</h2>\n"
  rank_table(['MVPɼ', 'MVP', 'ÿ'],
             us.sort do |a, b|
               [b[1].mvpcs, b[1].mvps, a[1].num] <=>
               [a[1].mvpcs, a[1].mvps, b[1].num]
             end.collect do |u|
               s = u[1]
               [u[0], "#{s.mvpcs}ɼ", "#{s.mvps}", "#{s.num}"]
             end)
end

def idl(id, nick)
  "<a href=\"matome.cgi?#{CGI.escape(id)}\">#{nick}</a>"
end

def senseki_table(cls_th, a, cls_proc)
  print "<table class=\"list\"><tr>"
  print "<th>#{cls_th}</th>"
  print "<th></th><th>Ψ</th>"
  print "<th>¸Ψ</th><th>̿</th>"
  print "<th>MVPɼ</th><th>MVP</th>"
  print "</tr>"
  a.each do |s|
    next if (s.num == 0)
    print "<tr>"
    print "<td>#{cls_proc.call(s.cls)}</td>"
    print "<td>#{s.wins}#{s.loses}</td><td>#{s.win_rate}%</td>"
    print "<td>#{s.live_rate}%</td><td>#{s.avg_dates}</td>"
    print "<td>#{s.mvpcs}ɼ</td><td>#{s.mvps}</td>"
    print "</tr>"
  end
  print "</table>"
end

def matome()
  us = Array.new
  Dir.open('backup/db/ur').each do |db|
    next if db !~ /\.db$/

    urdb = PStore.new("backup/db/ur/#{db}")
    urdb.transaction(true) do
      u = urdb['root']
      if (u && u.senseki && u.senseki.num >= NUM1)
        us.push(u)
      end
    end
  end

  userdb = PStore.new('backup/db/user.db')
  userdb.transaction(true) do
    rank_tables(us.collect do |u|
                  [idl(u.userid, u.nick), u.senseki]
                end)

    poses = ['¼', 'ϵ']
    poses.each_index do |i|
      pos = poses[i]
      rank_tables(us.select do |u|
                    u.senseki_ps[i].num >= NUM2
                  end.collect do |u|
                    [idl(u.userid, u.nick), u.senseki_ps[i]]
                  end, "#{pos}¦")
    end
  end
end

print(HEAD1)
print "<title>͹ 󥭥</title>"
print(HEAD2)

print %Q(
<p>
͹ӥ󥭥󥰤Ǥ

<p>
󥭥󥰤#{NUM1}ﻲü԰ʾ塢
Ω󥭥󥰤#{NUM2}ﻲü԰ʾ夬оݤˤʤäƤޤ

#{if (NUM1 > 3) then "<a href=\"ranking2.html\">äȤη</a>" end}
)

matome()

print(FOOT)
