#!/usr/bin/env ruby

$KCODE = "EUC"

require 'config'
require 'catalog'
require 'login'
require 'user_record'

require 'cgi'

module PrototypeBaseLike
  def method_missing(name, *arg)
    if (arg.size == 1 && name.to_s =~ /^(.*?)=$/)
      self[$1] = arg[0]
    elsif (arg.size == 0)
      self[name.to_s]
    else
      raise NameError.new("undefined method '#{name}' for #{self.class.name}",
                          name)
    end
  end
end

class Hash
  include PrototypeBaseLike
end

header_printed = false

begin
  cgi = CGI.new()

  @login = Login.new(cgi)

  print "Content-Type: text/html; charset=EUC-JP\n\n"
  header_printed = true

  print(HEAD1)
  print "<title>͹¼</title>"
  print(HEAD2)

  @login.form

  cmd = cgi['cmd']

  u = (cmd == nil) ? '' : CGI::unescape(ENV['QUERY_STRING'])

  ndb = PStore.new('notice.db')

  if (cmd.to_s != '')
    if (!@login.login)
      raise ErrorMsg.new('󤷤Ʋ')
    end

    mail = cgi['mail']

    ndb.transaction do
      if (!ndb.root?('notice'))
        ndb['notice'] = Array.new
      end

      ndb['notice'].reject! do |n|
        n.mail == mail && (n.userid == @login.userid || @login.master?)
      end

      if (cmd == 'set')
        n = Hash.new
        n.mail = mail
#        n.mkvil = (cgi['mkvil'] == '1')
        mkvil = cgi['mkvil'].to_i
        n.mkvil = mkvil == 4 ? false : mkvil
        n.userid = @login.userid
        n.nick = @login.nick
        ndb['notice'].push(n)
      end
    end
  end

  print %Q(<h2>͹¼</h2>

<p>
档
إʥᥢɤȤϿҤ㤭ޤ
</p>

<h2>Ͽ</h2>

<p>
<form method="GET">
<table border="1"><tr>
<td>᡼륢ɥ쥹</td>
<td><input name="mail"></td>
</tr>
<tr>
<td>¼</td>
<td>
<!-- <input type="checkbox" name="mkvil" value="1"> -->
<select name="mkvil">
<option value="4">¼Τ</option>
<option value="3">̤¼</option>
<option value="2" selected>ص̣ʾ</option>
<option value="1">ذʾ</option>
<option value="0">ƥȰʾ</option>
</select>
</td>
</tr>
</table>
<input type="hidden" name="cmd" value="set">
<input type="submit" value="Ͽ">
</form>
</p>
)

  if (@login.login)
    print %Q(<h2>#{@login.nick}Ͽ᡼륢ɥ쥹</h2>)
    print %Q(<p><form method="GET">)
    ndb.transaction(true) do
      ndb['notice'].each do |n|
        if (n.userid == @login.userid)
          print %Q(<input type="radio" name="mail" value="#{n.mail}">
#{n.mail}<br>)
        end
      end
    end
    print %Q(
<input type="hidden" name="cmd" value="del">
<input type="submit" name="del" value="">
</form>
</p>
)
  end

  if (@login.master?)
    print %Q(<h2>master</h2>)
    print %Q(<p><form method="GET">)
    ndb.transaction(true) do
      ndb['notice'].each do |n|
        print %Q(<input type="radio" name="mail" value="#{n.mail}">
#{n.mail} (#{n.nick})<br>)
      end
    end
    print %Q(
<input type="hidden" name="cmd" value="del">
<input type="submit" name="del" value="">
</form>
</p>
)
  end

  print(FOOT)
rescue
  print "Content-Type: text/html; charset=EUC-JP\n\n" unless header_printed
  print "<pre>\n"
  print CGI.escapeHTML("#{$!.to_s}\n")
  print CGI.escapeHTML("#{$!.backtrace.join("\n")}\n")
  print "</pre>\n"
end

