require 'skill'
require 'catalog'

class Player
  def Player.name(color, pid)
    NAMES[pid]
  end

  attr_reader :pid, :userid, :nick
  attr_accessor :sid
  attr_accessor :vote, :target, :msg, :dead
  attr_reader :cnt, :pt
  attr_reader :hist
  attr_accessor :survive, :death
  attr_accessor :prev_msg
  attr_accessor :commit

  def name
    NAMES[@pid]
  end

  def sname
    name.sub(/^[^ ]+ /, '')
  end

  def say(date, pt)
    for i in @cnt.size..date
      @cnt.push(0)
      @pt.push(0)
    end
    @cnt[date] += 1
    @pt[date] += pt
  end

  def skill
    Skill.skills[@sid]
  end

  def skill_name
    SKILLS[@sid]
  end

  def initialize(pid, userid, nick, skill, color)
    @pid = pid
    @userid = userid
    @nick = nick
    @sid = skill
    @dead = 0
    @color = color
    @commit = false

    @cnt = Array.new
    @pt = Array.new

    @hist = Array.new
  end

  def color
    p = (dead == 0) ? pid : 99
    if (@color)
      return "#{two(p)}_#{@color}"
    else
      return two(p)
    end
  end

  def can_whisper
    (@sid == 1 || @sid == 8 || @sid == 16) && @dead == 0
  end

  def all_pt
    s = 0
    @pt.each do |c|
      s += c
    end
    s
  end
  def all_cnt
    s = 0
    @cnt.each do |c|
      s += c
    end
    s
  end

  def add_hist(h)
    if (!@hist)
      @hist = Array.new
    end
    @hist.push(h)
  end

  def transform(p = nil)
    if p
      @orig = @pid if !@orig
      @pid = p
    else
      @pid = @orig if @orig
    end
  end

end

