function get_response_text ( req ) {
    var text = req.responseText;
    if ( navigator.appVersion.indexOf( "KHTML" ) > -1 ) {
        var esc = escape( text );
        if ( esc.indexOf("%u") < 0 && esc.indexOf("%") > -1 ) {
            text = decodeURIComponent( esc );
        }
    }
    return text;
}

function changeRegFilter(rstr) {
  var i;

  r = new RegExp(rstr)
  tr = /title=".*?"/g;

  elems = document.getElementsByTagName("div");
  for (i = 0; i < elems.length; i++) {
    var id = elems[i].id;
    if (id.substring(0, 3) == "say" || id.substring(0, 5) == "think" ||
        id.substring(0, 7) == "whisper" || id.substring(0, 5) == "groan") {
      h = elems[i].innerHTML.replace(tr, "");
      if (h.match(r)) {
        elems[i].style.display = "block";
      }
      else {
        elems[i].style.display = "none";
      }
    }
    else {
      if (id.substring(0, 6) == "action")
      {
        elems[i].parentNode.style.display = "none";
      }
    }
  }

  return false;
}

function changeFilter(pid) {
  var i;
  elems = document.getElementsByTagName("div");
  if (document.checks["filter"+pid].checked) {
    for (i = 0; i < elems.length; i++) {
      id = elems[i].id;
      if (id == "say"+pid+"p" || id == "think"+pid+"p" ||
          id == "whisper"+pid+"p" || id == "groan"+pid+"p" ||
          id == "action"+pid+"p")
      {
        elems[i].parentNode.style.display = "block";
      }
    }
  }
  else {
    for (i = 0; i < elems.length; i++) {
      id = elems[i].id;
      if (id == "say"+pid+"p" || id == "think"+pid+"p" ||
          id == "whisper"+pid+"p" || id == "groan"+pid+"p" ||
          id == "action"+pid+"p")
      {
        elems[i].parentNode.style.display = "none";
      }
    }
  }
}

function showAll() {
  for (var key in document.checks) {
    if (key.substring(0, 6) == "filter") {
      document.checks[key].checked = true;
      changeFilter(key.substring(6, key.length));
    }
  }
}

function hideAll() {
  for (var key in document.checks) {
    if (key.substring(0, 6) == "filter") {
      document.checks[key].checked = false;
      changeFilter(key.substring(6, key.length));
    }
  }
}

function getCookie(key) {
  var tmp = document.cookie + ";";
  var index1 = tmp.indexOf(key, 0);
  if(index1 != -1){
   tmp = tmp.substring(index1,tmp.length);
   var index2 = tmp.indexOf("=",0) + 1;
   var index3 = tmp.indexOf(";",index2);
   return(unescape(tmp.substring(index2,index3)));
  }
  return("");
}

function displayFilter() {
  var login = getCookie("login");
  var display = login.split(",")[2];
  var right = document.getElementById("right").style;

  if (!display || display == 3 || display == 0) {
    var aName = navigator.appName.toUpperCase();
    if (aName.indexOf("MICROSOFT") >= 0) {
      display = 1;
    }
    else {
      display = 2;
    }
  }

  if (right == null) return;
  if (display == 1) {
    document.getElementById("content").style.overflow = "auto";
    document.getElementsByTagName("body")[0].style.overflowY = "hidden";
    right.display = "block";
  }
  else if (display == 2) {
    right.display = "block";
    right.position = "fixed";
  }
  right.overflow = "auto";
}

function createXmlHttp ()
{
  try {
    xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
  } catch (e) {
    try {
      xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
    } catch (e) {
      xmlhttp = false;
    }
  }
  if (!xmlhttp && typeof XMLHttpRequest != 'undefined') {
    xmlhttp = new XMLHttpRequest();
  }

  return xmlhttp;
}

var prev_body = false;
function preview_cancel() {
    m = document.getElementById("discuss");
    m.innerHTML = prev_body;
    prev_body = false;
}
function preview(f) {
    if (f['message'].value == '') return true;

    m = document.getElementById("discuss");
    if (!prev_body) {
        prev_body = m.innerHTML;
    }
    qns = ['cmd','vid','pid','loud','think','whisper','groan','twop'];
    var q = "";
    for (qi in qns) {
        qn = qns[qi];
        i = f[qn];
        if (i) {
            if (i.type == 'checkbox') {
                if (i.checked) q += qn+"=on&";
            }
            else {
                q += qn+"="+i.value+"&";
            }
        }
    }
    q += "message=" + encodeURIComponent(f['message'].value);

    var xmlhttp = createXmlHttp();
    xmlhttp.open("POST", "preview.cgi", false);
    xmlhttp.send(q);
/*
    xmlhttp.open("GET", "preview.cgi?" + q, false);
    xmlhttp.send(null);
*/
    var res = get_response_text(xmlhttp);

    m.innerHTML = res;
    window.scroll(0, 80);
    return false;
}

function goBottom() {
    if (navigator.appName.toUpperCase().indexOf("MICROSOFT") >= 0 &&
        location.href.match(/#bottom$/))
    {
        location.hash = "bottom";
    }
}
