require 'catalog'

class Skill
  attr_reader :name, :default_num, :sid, :position, :sname

  @@cnt = 0

  def initialize(name, default_num, position, sname, action_proc)
    @name = name
    @default_num = default_num
    @position = position
    @action_proc = action_proc
    @sname = sname

    @sid = @@cnt
    @@cnt += 1
  end

  def action(cgi, vil, player)
    @action_proc.call(cgi, vil, player)
  end

  def desc
    %Q(ʤ<a class="say" href="?cmd=doc#skill#{two(@sid)}">#{SKILLS[@sid]}</a>Ǥ) + SKILL_DESCS[@sid]
  end

  def Skill.skills
    @@skills
  end

  noproc = Proc.new { |cgi, vil, player| }

  target_action = Proc.new do |cgi, vil, player|
    raise ErrorMsg.new('оݤåȤƤޤ') if (!cgi['pid'])
    if (cgi['pid'] == '')
      player.target = nil
    else
      player.target = cgi['pid'].to_i
    end
  end

  a = Array.new
  a.push(Skill.new('¼', 3, '¼', '¼', noproc)) # 0
  a.push(Skill.new('ϵ', 2, 'ϵ', 'ϵ', target_action)) # 1
  a.push(Skill.new('ꤤ', 1, '¼', '', target_action)) # 2
  a.push(Skill.new('ǽ', 1, '¼', '', noproc)) # 3
  a.push(Skill.new('', 1, 'ϵ', '', noproc)) # 4
  a.push(Skill.new('', 0, '¼', '', target_action)) # 5
  a.push(Skill.new('ͭ', 0, '¼', '', noproc)) # 6
  a.push(Skill.new('', 0, '', '', noproc)) # 7
  a.push(Skill.new('ö', 0, 'ϵ', '', noproc)) # 8
  a.push(Skill.new('', 0, 'ϵ', '', noproc)) # 9
  a.push(Skill.new('', 0, '¼', '', noproc)) # 10
  a.push(Skill.new('', 0, '¼', '', target_action)) # 11
  a.push(Skill.new('', 0, '¼', '', target_action)) # 12
  a.push(Skill.new('', 0, 'ϵ', '', target_action)) # 13
  a.push(Skill.new('ļ', 0, '¼', '', noproc)) # 14
  a.push(Skill.new('', 0, '¼', '', target_action)) # 15
  a.push(Skill.new('ϵ᤭', 0, 'ϵ', '', target_action)) # 16
  a.push(Skill.new('ϵ', 0, 'ϵ', '', target_action)) # 17
  a.push(Skill.new('޻', 0, '¼', '', noproc)) # 18
  a.push(Skill.new('봱', 0, '¼', '', noproc)) # 19

  @@skills = a

#  @@descs = SKILL_DESCS
end

