require 'config'

require 'net/http'

require 'tsslog'
require 'tsslock'

def http_get(srv, path, file, pass)
  tsslog('GET', "srv=#{srv} path=#{path} file=#{file}")
  File.open(file, 'w') do |of|
    Net::HTTP.version_1_2
    Net::HTTP.start(srv) do |http|
      req = Net::HTTP::Get.new(path + file)
      req.basic_auth('she', pass)
      res = http.request(req)
      if (res.code != '200')
        raise ErrorMsg.new('餯ǧڤǤƤޤshe˥ѥɤǧƲ')
      end
      of.print(res.body)
    end
  end
end

def http_post(cname, srv, path, file)
  head = "#{MASTER}:#{TK_TOKEN}:#{file}\n"
  cont = File.open(file) do |ifile|
    ifile.read
  end

  rescode = -1
  begin
    http = Net::HTTP.new(srv)
    http.open_timeout = 5
    http.read_timeout = 5
    http.start do |http|
#    Net::HTTP.start(srv) do |http|
      res = http.request_post(path+"sync.cgi", head+cont)
      rescode = res.code.to_i
    end
  rescue Timeout::Error
  rescue
  end

  if (rescode != 200)
    lock = TSSLock.new(COUNTRY_NAME)
    lock.freeze(cname)
  end

  tsslog('POST', "srv=#{srv} path=#{path} file=#{file} res=#{rescode}")
end

def http_broadcast(file)
  srvdb = Store.new('db/srv.db')
  srvdb.transaction(true) do
    srvdb.roots.each do |k|
      next if (k == COUNTRY_NAME)
      s = srvdb[k]
      if !s.key?('expired')
        http_post(k, s['serv'], s['path'], file)
      end
    end
  end
end
