require 'config'

require 'net/http'

require 'tsslog'

class TSSLock
  attr_reader :locked

  def initialize(owner)
    @owner = owner
    @locked = false
  end

  def lock(func)
    res = Net::HTTP.get(LOCK_SERV,
                        "#{LOCK_PATH}?cmd=lock&func=#{func}&owner=#{@owner}")
    tsslog('LOCK', res)
    if (res == 'ok')
      @locked = true
    end
    return @locked
  end

  def unlock(func)
    res = Net::HTTP.get(LOCK_SERV,
                        "#{LOCK_PATH}?cmd=unlock&func=#{func}&owner=#{@owner}")
    tsslog('UNLOCK', res)
    if (res == 'ok')
      @locked = false
    end
    return !@locked
  end

  def freeze(srv)
    res = Net::HTTP.get(LOCK_SERV,
                        "#{LOCK_PATH}?cmd=freeze&owner=#{@owner}&freeze=#{srv}")
    tsslog('FREEZE', res)
  end

end
