class UserRecord
  class Vil
    attr_accessor :vname, :vid, :name, :win, :skill, :position
    attr_accessor :survive, :death, :comment
    attr_accessor :cnt, :pt, :hist, :mvp_pt, :mvp
    attr_accessor :vs
  end

  attr_reader :userid, :nick
  attr_reader :vils
  attr_accessor :intro
  attr_accessor :filter, :preview

  def initialize(userid, nick)
    @userid = userid
    @nick = nick
    @vils = Array.new
  end

  def add_vil(vil)
    @vils.unshift(vil)
    update
  end

  def del_vil(vid)
    @vils.reject! do |v|
      v.vid == vid
    end
    update
  end

  def sorted_vils
    vils.sort do |v1, v2|
      v2.vid <=> v1.vid
    end
  end

  class Senseki
    attr_accessor :cls
    attr_accessor :num, :wins, :loses, :lives, :dates, :mvps, :mvpcs
    attr_accessor :win_rate, :live_rate, :avg_dates

    def to_s
      "#{wins} #{loses} (Ψ #{win_rate}%), ¸Ψ #{live_rate}%, ʿѼ̿ #{avg_dates}, MVP#{mvps}, MVPɼ#{mvpcs}ɼ"
    end
  end

  attr_reader :senseki, :senseki_ps, :senseki_sk, :senseki_pl

  def calc_senseki(vils, cls = nil)
    s = Senseki.new
    s.cls = cls
    num = 0
    wins = 0
    loses = 0
    lives = 0
    dates = 0
    mvps = 0
    mvpcs = 0
    vils.each do |v|
      num += 1
      if (v.win)
        wins += 1
      else
        loses += 1
      end
      lives += (v.death == '¸') ? 1 : 0
      dates += v.survive
      mvps += 1 if (v.mvp)
      mvpcs += v.mvp_pt.to_i
    end

    s.num = num
    s.wins = wins
    s.loses = loses
    s.lives = lives
    s.dates = dates
    s.mvps = mvps
    s.mvpcs = mvpcs
    if (vils.size == 0)
      s.win_rate = 0
      s.live_rate = 0
      s.avg_dates = 0
    else
      s.win_rate = wins*100/num
      s.live_rate = lives*100/num
      s.avg_dates = (dates.to_f*10/num).to_i*0.1
    end

    s
  end

  def update
    @senseki = calc_senseki(@vils)
    @senseki_ps = ['¼', 'ϵ', ''].collect do |p|
      calc_senseki(@vils.select {|v| v.position == p}, p)
    end
    @senseki_sk = ['¼', 'ϵ', 'ꤤ', 'ǽ', '', '', 'ͭ', '', 'ö', '', '', '', '', '', 'ϵ᤭', 'ϵ', '޻', '봱'].collect do |p|
      calc_senseki(@vils.select {|v| v.skill == p}, p)
    end
    @senseki_pl = [
      'ŷ ',
      '¼Ĺ 륿',
      'Ϸ ⡼å',
      ' ॾ',
      'ڤ ȡޥ',
      'ι ˥饹',
      'ʤ餺 ǥ',
      'ǯ ڡ',
      ' ꡼',
      'Ծ ӥ',
      'ӻ ',
      'ѥ åȡ',
      'ǯ 襢ҥ',
      '¼̼ ѥ',
      ' 䥳',
      'ɲν 쥸',
    ].collect do |p|
      calc_senseki(@vils.select {|v| v.name == p}, p)
    end
    self
  end

end

